#ifndef PacketBuf_h
#define PacketBuf_h

#include <sys/time.h>

#include "MNLClient.h"

class PacketBuf {

public:

  PacketBuf* Create(SendMsg* ipSendMsg, struct timeval iToSendTime);

private:

  PacketBuf(SendMsg* ipSendMsg, struct timeval iToSendTime);
  
  /** The contents of the packet to be sent out */
  uint8_t mpPktContents[MAX_PKT_LEN];

  /** The length of the packet to be sent out */
  int mPktLen;
 
  /** Where should this packet be sent.  All internal fields in network byte order.
    */
  struct sockaddr_in mToAddr;

  /** The length of mToAddrLen */
  socklen_t mToLen;

  /** The flags associated with the sendto call */
  int mFlags;

  int mDataLen;
  int mSeqNumStart;
  int mWindowSize;

  struct timeval mToSendTime;

  friend class PacketBufComparator;
  friend class SendQueue;
};

#endif //PacketBuf_h
