/**
  * This is the main program associated with MyNetLayer daemon.
  */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <signal.h>

#include "MNLDaemon.h"

static MNLDaemon* gpDaemon = NULL;

void usage(char* ipProgName) {
  printf ("\n"
          "Usage: %s <Config File Name>\n"
          "\n",
          ipProgName
        );
}

void CaughtSignal(int signum) {
  if (gpDaemon != NULL) {
    delete(gpDaemon);
  }
  exit(0);
}


int main(int argc, char* argv[]) {

  // Catch Ctrl-C
  signal (SIGINT, CaughtSignal);

  if (argc <  2) {
    usage(argv[0]);
    exit(1);
  }
  
  gpDaemon = new MNLDaemon();
  if (!gpDaemon->Init(argv[1])) {
    printf ("MNL: Fatal Error: Unable to initialize the MyNetLayer daemon.\n");
    exit (1);
  }

  gpDaemon->MainLoop();
}
